Function.prototype.andThen = function(secondFunction) {
  var firstFunction = this;
  
  return function() {
    var result = firstFunction.apply(this, arguments);
    return secondFunction.call(this, result);
  }
}

var printResult = function(value, msg, fn) {
  console.log(value + ' ' + msg + ' ' + fn(value));
}

var double = function(n) { return n * 2; }
var increment = function(n) { return n + 1; }

printResult(5, 'doubled is', double);
printResult(5, 'incremented is', increment);

//double and increment.
// var temp = double(5);
// printResult(temp, 'doubled and incremented', increment);

printResult(5, 'doubled and incremented', double.andThen(increment));

printResult(5, 'incremented and doubled', increment.andThen(double));